<?php 
//exit('remove');
ini_set('display_errors', 1); ini_set('display_startup_errors', 1); error_reporting(E_ALL);
require 'google-api-vendor/autoload.php'; 
$data = file_get_contents('php://input');
file_put_contents('data.txt',$data);
//$data = file_get_contents('data.txt');
$webhook_arr = json_decode($data,true);
use Google\Client;

if(isset($webhook_arr['data']['card']['id']))
{
    $card_id = $webhook_arr['data']['card']['id'];
    $json = getCardDetails($card_id);
    $card_detail = json_decode($json,true);
    /*echo "<pre>";
    print_r($card_detail);
    echo "</pre>";*/
    
    if(isset($card_detail['data']['card']['id']))
    {
        $title = $card_detail['data']['card']['title'];
        $pipeline_name = $card_detail['data']['card']['pipe']['name'];
        $category = getCategory($pipeline_name);
        $phase = $card_detail['data']['card']['current_phase']['name'];
        $created = $card_detail['data']['card']['created_at'];
        $link = "https://app.pipefy.com/open-cards/".$card_detail['data']['card']['id'];
        $requester = "";
        foreach($card_detail['data']['card']['fields'] as $key=>$field)
        {
            if($field['name'] == "Requester")
            {
                $requester = $field['value'];
                break;
            }
        }
        
        /*echo $sheet_category."  ".$title;
        exit;*/
        
        $client = new Client();
        $client->setScopes([Google_Service_Sheets::SPREADSHEETS]);
        $client->setAuthConfig('for-pipefy-9e8cc35679da.json');
        $client->setAccessType('offline');
        $client->setSubject('usingforpipefy@for-pipefy.iam.gserviceaccount.com'); // Leave empty if using domain-wide delegation
        
        $sheet_rows = getSheetRows($client);
        
        $row_exists = false;
        $row_no = 0;
        foreach($sheet_rows as $key=>$row)
        {
            if($row[0] == $title)
            {
                $row_exists = true;
                $row_no = $key+1;
                /*echo 'exists';
                echo $row_no;
                exit;*/
                break;
            }
        }
        
        if($row_exists == false)
        {
            $newRowData = [
                        $title,
                        $category,
                        $phase,
                        $created,
                        $link,
                        $requester,
                        '',
                        '',
                        '',
                        '',
                        '',
                        ''
                    ];
            $create_resp = createRow($client,$newRowData);    
        }
        else
        {
            $newRowData = [
                        $title,
                        $category,
                        $phase,
                        $created,
                        $link,
                        $requester,
                        '',
                        '',
                        '',
                        '',
                        '',
                        ''
                    ];
                    
            $update_resp = updateRow($client,$newRowData,$row_no);
        }
        /*echo "<pre>";
        print_r($create_resp);
        print_r($update_resp);
        print_r($webhook_arr);
        print_r($card_detail);
        print_r($sheet_rows);
        echo "</pre>";*/
        exit;
    }
    
}

function getSheetRows($client)
{
    $sheetsService = new Google_Service_Sheets($client);
    $spreadsheetId = '1sfQgTq-0OewMJd2pIkSRN8FiEVQtXDsfH120wTze29A';
    $range = 'A:L';
    
    $response = $sheetsService->spreadsheets_values->get($spreadsheetId,$range);
    $sheet_rows = $response->getValues();
    return $sheet_rows;
}

function createRow($client,$newRowData)
{
    $sheetsService = new Google_Service_Sheets($client);
    $spreadsheetId = '1sfQgTq-0OewMJd2pIkSRN8FiEVQtXDsfH120wTze29A';
    $range = 'A:L'; // Adjust the range to cover the columns you want to append data to
    $body = new Google_Service_Sheets_ValueRange(['values' => [$newRowData],]);
    
    $params = [
        'valueInputOption' => 'RAW', // Use 'RAW' if your data doesn't need any formatting
    ];
    
    // Append the new row to the sheet
    $result = $sheetsService->spreadsheets_values->append($spreadsheetId, $range, $body, $params);
    return $result;
}

function updateRow($client,$newRowData,$row_no)
{
    $sheetsService = new Google_Service_Sheets($client);
    $spreadsheetId = '1sfQgTq-0OewMJd2pIkSRN8FiEVQtXDsfH120wTze29A';
    $range = 'A'.$row_no.':L'.$row_no; // Adjust the range to cover the columns you want to append data to
    $body = new Google_Service_Sheets_ValueRange(['values' => [$newRowData],]);
    
    $params = [
        'valueInputOption' => 'RAW', // Use 'RAW' if your data doesn't need any formatting
    ];
    
    // Append the new row to the sheet
    $result = $sheetsService->spreadsheets_values->update($spreadsheetId, $range, $body, $params);
    return $result;
}


function getCategory($pipeline_name)
{
    switch($pipeline_name){
        case "OPS - Solar":
            $category = "Solar";
            break;
        case "Service Call - Solar":
            $category = "Service Call - Solar";
            break;
        case "Service Call - Lighting/Other":
            $category = "Service - Lighting/Other";
            break;
        case "OPS - EV & Storage":
            $category = "EV/Storage";
            break;
        case "OPS - Lighting - SBS":
            $category = "Lighting - SBS";
            break;
        case "OPS - Lighting - Pres. & Signs":
            $category = "Lighting - Prescriptive";
            break;
        case "default":
            $category = "Not matched";
            break;
    }
    
    return $category;
        
}
function getCardDetails($card_id)
{
    $curl = curl_init();
    curl_setopt_array($curl, array(
      CURLOPT_URL => 'https://api.pipefy.com/graphql',
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => '',
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 0,
      CURLOPT_FOLLOWLOCATION => true,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => 'POST',
      CURLOPT_POSTFIELDS =>'{"query":"query {\\r\\n  card(id: '.$card_id.') {\\r\\n id \\r\\n created_at \\r\\n updated_at \\r\\n title \\r\\n    pipe {\\r\\n      id\\r\\n      name\\r\\n    }\\r\\n   current_phase {\\r\\n id \\r\\n name \\r\\n }\\r\\n fields {\\r\\n      name\\r\\n      value\\r\\n      filled_at\\r\\n    }\\r\\n    current_phase {\\r\\n      id\\r\\n      name\\r\\n    }\\r\\n    assignees {\\r\\n      name\\r\\n      email\\r\\n    }\\r\\n  }\\r\\n}","variables":{}}',
      CURLOPT_HTTPHEADER => array(
        'Authorization: Bearer eyJhbGciOiJIUzUxMiJ9.eyJpc3MiOiJQaXBlZnkiLCJpYXQiOjE2ODk3NTcyNTcsImp0aSI6Ijc5MGYwZjIyLWI3MWItNGQ4Ny1iY2I5LWE1NzZjMjI3NTQ2MyIsInN1YiI6MjQwMzg2LCJ1c2VyIjp7ImlkIjoyNDAzODYsImVtYWlsIjoiY2hyaXNAZW5lcmd5c2VsZWN0bGxjLmNvbSIsImFwcGxpY2F0aW9uIjozMDAyNjE4MDUsInNjb3BlcyI6W119LCJpbnRlcmZhY2VfdXVpZCI6bnVsbH0.HCox7PrggWSGzkcrR5sKgwkUynSFWNU28EyI7R9O18ZX4vN8LqFVJoZj7QcHRwGp-7IuNBP7E3BpKNU80gsGVw',
        'Content-Type: application/json',
      ),
    ));
    
    $response = curl_exec($curl);
    
    curl_close($curl);
    return $response;
}

?>